# coding: utf-8

"""
    Pulp 3 API

    Fetch, Upload, Organize, and Distribute Software Packages  # noqa: E501

    The version of the OpenAPI document: v3
    Contact: pulp-list@redhat.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from pulpcore.client.pulp_rpm.configuration import Configuration


class Copy(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'config': 'object',
        'dependency_solving': 'bool'
    }

    attribute_map = {
        'config': 'config',
        'dependency_solving': 'dependency_solving'
    }

    def __init__(self, config=None, dependency_solving=True, local_vars_configuration=None):  # noqa: E501
        """Copy - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._config = None
        self._dependency_solving = None
        self.discriminator = None

        self.config = config
        if dependency_solving is not None:
            self.dependency_solving = dependency_solving

    @property
    def config(self):
        """Gets the config of this Copy.  # noqa: E501

        A JSON document describing sources, destinations, and content to be copied  # noqa: E501

        :return: The config of this Copy.  # noqa: E501
        :rtype: object
        """
        return self._config

    @config.setter
    def config(self, config):
        """Sets the config of this Copy.

        A JSON document describing sources, destinations, and content to be copied  # noqa: E501

        :param config: The config of this Copy.  # noqa: E501
        :type: object
        """
        if self.local_vars_configuration.client_side_validation and config is None:  # noqa: E501
            raise ValueError("Invalid value for `config`, must not be `None`")  # noqa: E501

        self._config = config

    @property
    def dependency_solving(self):
        """Gets the dependency_solving of this Copy.  # noqa: E501

        Also copy dependencies of the content being copied.  # noqa: E501

        :return: The dependency_solving of this Copy.  # noqa: E501
        :rtype: bool
        """
        return self._dependency_solving

    @dependency_solving.setter
    def dependency_solving(self, dependency_solving):
        """Sets the dependency_solving of this Copy.

        Also copy dependencies of the content being copied.  # noqa: E501

        :param dependency_solving: The dependency_solving of this Copy.  # noqa: E501
        :type: bool
        """

        self._dependency_solving = dependency_solving

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Copy):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, Copy):
            return True

        return self.to_dict() != other.to_dict()
