# coding: utf-8

"""
    Pulp 3 API

    Fetch, Upload, Organize, and Distribute Software Packages  # noqa: E501

    The version of the OpenAPI document: v3
    Contact: pulp-list@redhat.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from pulpcore.client.pulp_rpm.configuration import Configuration


class RpmModulemdDefaults(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'repository': 'str',
        'module': 'str',
        'stream': 'str',
        'profiles': 'object',
        'snippet': 'str'
    }

    attribute_map = {
        'repository': 'repository',
        'module': 'module',
        'stream': 'stream',
        'profiles': 'profiles',
        'snippet': 'snippet'
    }

    def __init__(self, repository=None, module=None, stream=None, profiles=None, snippet=None, local_vars_configuration=None):  # noqa: E501
        """RpmModulemdDefaults - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._repository = None
        self._module = None
        self._stream = None
        self._profiles = None
        self._snippet = None
        self.discriminator = None

        if repository is not None:
            self.repository = repository
        self.module = module
        self.stream = stream
        self.profiles = profiles
        self.snippet = snippet

    @property
    def repository(self):
        """Gets the repository of this RpmModulemdDefaults.  # noqa: E501

        A URI of a repository the new content unit should be associated with.  # noqa: E501

        :return: The repository of this RpmModulemdDefaults.  # noqa: E501
        :rtype: str
        """
        return self._repository

    @repository.setter
    def repository(self, repository):
        """Sets the repository of this RpmModulemdDefaults.

        A URI of a repository the new content unit should be associated with.  # noqa: E501

        :param repository: The repository of this RpmModulemdDefaults.  # noqa: E501
        :type: str
        """

        self._repository = repository

    @property
    def module(self):
        """Gets the module of this RpmModulemdDefaults.  # noqa: E501

        Modulemd name.  # noqa: E501

        :return: The module of this RpmModulemdDefaults.  # noqa: E501
        :rtype: str
        """
        return self._module

    @module.setter
    def module(self, module):
        """Sets the module of this RpmModulemdDefaults.

        Modulemd name.  # noqa: E501

        :param module: The module of this RpmModulemdDefaults.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and module is None:  # noqa: E501
            raise ValueError("Invalid value for `module`, must not be `None`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                module is not None and len(module) < 1):
            raise ValueError("Invalid value for `module`, length must be greater than or equal to `1`")  # noqa: E501

        self._module = module

    @property
    def stream(self):
        """Gets the stream of this RpmModulemdDefaults.  # noqa: E501

        Modulemd default stream.  # noqa: E501

        :return: The stream of this RpmModulemdDefaults.  # noqa: E501
        :rtype: str
        """
        return self._stream

    @stream.setter
    def stream(self, stream):
        """Sets the stream of this RpmModulemdDefaults.

        Modulemd default stream.  # noqa: E501

        :param stream: The stream of this RpmModulemdDefaults.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and stream is None:  # noqa: E501
            raise ValueError("Invalid value for `stream`, must not be `None`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                stream is not None and len(stream) < 1):
            raise ValueError("Invalid value for `stream`, length must be greater than or equal to `1`")  # noqa: E501

        self._stream = stream

    @property
    def profiles(self):
        """Gets the profiles of this RpmModulemdDefaults.  # noqa: E501

        Default profiles for modulemd streams.  # noqa: E501

        :return: The profiles of this RpmModulemdDefaults.  # noqa: E501
        :rtype: object
        """
        return self._profiles

    @profiles.setter
    def profiles(self, profiles):
        """Sets the profiles of this RpmModulemdDefaults.

        Default profiles for modulemd streams.  # noqa: E501

        :param profiles: The profiles of this RpmModulemdDefaults.  # noqa: E501
        :type: object
        """
        if self.local_vars_configuration.client_side_validation and profiles is None:  # noqa: E501
            raise ValueError("Invalid value for `profiles`, must not be `None`")  # noqa: E501

        self._profiles = profiles

    @property
    def snippet(self):
        """Gets the snippet of this RpmModulemdDefaults.  # noqa: E501

        Modulemd default snippet  # noqa: E501

        :return: The snippet of this RpmModulemdDefaults.  # noqa: E501
        :rtype: str
        """
        return self._snippet

    @snippet.setter
    def snippet(self, snippet):
        """Sets the snippet of this RpmModulemdDefaults.

        Modulemd default snippet  # noqa: E501

        :param snippet: The snippet of this RpmModulemdDefaults.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and snippet is None:  # noqa: E501
            raise ValueError("Invalid value for `snippet`, must not be `None`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                snippet is not None and len(snippet) < 1):
            raise ValueError("Invalid value for `snippet`, length must be greater than or equal to `1`")  # noqa: E501

        self._snippet = snippet

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, RpmModulemdDefaults):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, RpmModulemdDefaults):
            return True

        return self.to_dict() != other.to_dict()
